// Original:  Jason Fondren (usher@betterbox.net) -->
// Heavily Modified for Nokia 5800:  Nigel Morton (widgets@ntpworld.co.uk)-->
// Web Site:  http://www.ntpworld.co.uk/ -->

// Further development by Markus Meriluoto (info@moubail.com)
// Added more symbols, persistant scoring system, other tweaks
// Web Site: http://www.moubail.com

var imgpath='img/';
var scores;
var lastscore;
var highscore;
var clickscore;
var overlay;
var popup;
var message;
var alertTimerId = 0;
var clickNumber = 0;
var ballNumber = -1;
var rows = 7;
var clearingbonus = 300;
var clickTimeout = 4;       //Seconds to wait from click before removing balls



//	Declare the total score and the winner variable.
var total = 0;
var winner = 0;
var cols=15;

    //if (widget.isrotationsupported == false)       // change the screen orientation
        //cols = 11;

//	The random number function.
function random() {
ballCount = 4;
randomNum = Math.floor((Math.random() * ballCount));
randomNum++;
return randomNum;
}

// For touch screen, first click shows the balls that will be removed,
// second click cancels the balls - uses javascript timer to remove balls if not cancelled
function clickBallSelect(numba){
if(ballNumber == -1)
    ballNumber = numba;
else
{
if(ballNumber != numba){    //Unselect the previous balls and set clickball to 0 so we select the new group
    clickNumber = 0;
    offBall(ballNumber);
    }
}

ballNumber = numba;
if(clickNumber == 0){
    clickNumber = 1;
    onBall(numba);
    }
else
    {
    //clickNumber = 0;
    //offBall(numba);
	clickBall();
    }
}

//	Uses findAdjacent() to find connected balls of the same color. Called on first ball click, changes
//	the ball image to alert user of how many balls will be removed.
function onBall(numba) {
  if (main[numba] != 0) {
    alertTimerId = setTimeout("clickBall()", clickTimeout * 1000);

    crayon = main[numba];
    findAdjacent(numba);
    if (adj.length > 1) {
      for (n = 0; n < adj.length; n++) {
        document["img" + adj[n]].src = eval("on" + crayon + ".src");
        //document.scores.click.value = (adj.length-2)*(adj.length-2);
		
		clickscore.innerHTML = "+"+(adj.length-1)*(adj.length-1);
         }
      }
   }
}

//	Uses findAdjacent() to find connected balls of the same color. Turns off the alternate
//	balls on mouseout.
function offBall(numba) {
  if (main[numba] != 0) {
    clearTimeout(alertTimerId);
    crayon = main[numba];
    findAdjacent(numba);
    if (adj.length > 1) {
      for (n = 0; n < adj.length; n++) {
        document["img" + adj[n]].src = eval("off" + crayon + ".src");
        //document.scores.click.value = 0;
		clickscore.innerHTML = "";
        }
      }
   }
}

//	Uses findAdjacent() to find connected balls of the same color. Removes selected balls by
//	changing the value to 0, cleans up columns using slideBalls(), updates the game board
//	with drawBalls(), adjusts the score, and checks to see if the game board is cleared with
//	checkwinner() or if all the removable pieces are taken with checkLoser().
//  If a winner then the board is re-seeded with balls and the play continues.
function clickBall() {
	clearTimeout(alertTimerId);
  	numba=ballNumber;

  if (main[numba] != 0) {
    findAdjacent(numba);
    if (adj.length > 1) {
      for (n=0; n<adj.length; n++) {
          main[adj[n]] = 0;
          }
        slideBalls();
        drawBalls();
        total = (adj.length - 1) * (adj.length - 1) + total;
        scores.innerHTML = total;
        clickscore.innerHTML = "";
        clickNumber = 0;
        ballNumber = -1;

        //See if the board is clear and if so re seed it
		if (checkWinner()) {
			for (i = 0; i < (cols * rows); i++) {
              main[i] = random();
			}
			gameover('all');
        }
        q = 0;
        checkLoser();
        if (q == 60 && winner == 0) {
			gameover('failed');
          }        
        }
     }
}

function gameover(success) {
	overlay.style.display = "block";
	popup.style.display = "block";
	
	currenttopscore = Number(widget.preferenceForKey('highscorekey'));
	
	if(success == "all") {
		total = total+clearingbonus;
		
		if(total>currenttopscore) {
			saveValue(total,'highscorekey');
			message.innerHTML = "<h5>Game Over! New Top Score!!</h5>You earned "+clearingbonus+" bonus points for clearing the board!<br />Your final score is<div class='finalscore'>"+total+"</div>"
		}
		else {		
			message.innerHTML = "<h5>Game Over!</h5>You earned "+clearingbonus+" bonus points for clearing the board!<br />Your final score is<div class='finalscore'>"+total+"</div>"
		}
	}
	
	else {		

		if(total>currenttopscore) {
			saveValue(total,'highscorekey');
			message.innerHTML = "<h5>Game Over! New Top Score!!</h5>Your final score was<div class='finalscore'>"+total+"</div>"
		}
		else {
			message.innerHTML = "<h5>Game Over!</h5>Your final score was<div class='finalscore'>"+total+"</div>"
		}
	}
}
// Handle scores
function saveValue(field, key) {
	//alert("Saving: "+field+","+ key);
	widget.setPreferenceForKey(field, key);
}
function loadSavedValue(field, key) {
	//alert("Loading: "+field+","+ key);
	var value = Number(widget.preferenceForKey(key));
	
	if(value)
	{
		field.innerHTML = value;
	}
	else
	{
		widget.setPreferenceForKey('0', key);
		field.innerHTML = "0";
	}
}
function updateScore() {	
	var highstring = Number(widget.preferenceForKey('highscorekey'));
	var laststring = Number(widget.preferenceForKey('lastscorekey'));
	
	if (total > 0) {
		saveValue(total, 'lastscorekey')
	}
	loadSavedValue(lastscore, 'lastscorekey');
	
	if (total > Number(widget.preferenceForKey('lastscorekey'))) {
		saveValue(total, 'highscorekey')
	}
	loadSavedValue(highscore, 'highscorekey');

	//alert("Update scores: "+total+", "+laststring+", "+highstring);
}


// Reset game
function reset() {
	for (i = 0; i < (cols * rows); i++)
	{
		main[i] = random();
	}
	drawBalls();
		
	updateScore();
	
	total = 0;
	clickscore.innerHTML = "";
	overlay.style.display = "none";
	popup.style.display = "none";
}

// Screens
function intro() {
	document.getElementById('intro').style.display = "block";
	document.getElementById('info').style.display = "none";
	document.getElementById('game').style.display = "none";
}
function info() {
	document.getElementById('intro').style.display = "none";
	document.getElementById('info').style.display = "block";
	document.getElementById('game').style.display = "none";
}
function game() {
	document.getElementById('intro').style.display = "none";
	document.getElementById('info').style.display = "none";
	document.getElementById('game').style.display = "block";
}

//	Rolls through the remaining balls
//	and checks to see if any more can
//	be removed with smallAdjacent().
function checkLoser() {
if (q == 60) {
return true
}
if (main[q] != 0) {
if (smallAdjacent(q)) {
return false;
   }
}
q++;
checkLoser();
}

//	Checks to see if the game was won.
//	Simply checks main[0], and if it equals 0 returns true
function checkWinner() {
if (main[0] == 0) {
    return true;
   }
}

//	A smaller faster version of
//	findAdjacent2(). Runs through
//	the balls until it finds the first
//	set of adjacent balls. Used by
//	checkLoser() to determine if the
//	game is over.

function smallAdjacent(numba) {
isBottom = 0;
isHead = 0;
for (n = 0; n < rows*2; n++) {
if (numba == head[n]) {
isHead = 1;
   }
}
for (n = 0; n < rows*2; n++) {
if (numba == bottom[n]) {
isBottom = 1;
   }
}
if (main[numba + 1] == main[numba] && isHead != 1) {
return true;
}
if (main[numba + rows] == main[numba]) {
return true;
}
if (main[numba - 1] == main[numba] && isBottom != 1) {
return true;
}
if (main[numba - rows] == main[numba]) {
return true;
}
return false;
}

//	Slides all non-0 balls down the column
//	and places the zeroed balls at the top
//	of each column.
//	If all balls in a column are marked with
//	a 0, all subsequent columns are moved left
//	and the last column is zeroed out.

function slideBalls() {
change = 0;
for (i = 0; i < cols; i++) {
blankCount = 0;
column = new Array();
newColumn = new Array();
for (c = 0; c < rows; c++) {
column[c] = main[c + change];
}
for (c = 0; c < rows; c++) {
if (column[c] == 0) {
blankCount++;
newColumn[rows-blankCount] = 0;
}
else {
newColumn[c - blankCount] = column[c];
   }
}
for (c = 0; c < rows; c++) {
main[c + change] = newColumn[c];
}
if (blankCount == rows) {
for (c = change; c < cols * rows; c++) {
main[c] = main[c + rows];
}
for (c = cols * (rows-1); c < cols * rows; c++) {
main[c] = 0;
}
change -= rows;
}
change += rows;
   }
}

//	Draws the balls on the game board based on the values of the "main" Array.
//	0=blank  1=red  2=yellow  3=blue
function drawBalls() {
//document.scores.show.value = 0;
scores.innerHTML = 0;
for (i = 0; i < main.length; i++) {
    crayon = main[i];
    document["img" + i].src = eval("off" + crayon + ".src");
   }
}

//  Initial function
//	Preload and identify all of the images.
//	Default config for the script only uses
//	three different colored balls.
//	0=blank  1=red  2=yellow  3=blue
function startUp() {
if (widget.isrotationsupported) {
	widget.setDisplayLandscape();
	window.menu.hideSoftkeys();
}
scores = document.getElementById("scores");
lastscore = document.getElementById("lastscore");
highscore = document.getElementById("highscore");
clickscore = document.getElementById("clickscore");
overlay = document.getElementById("overlay");
popup = document.getElementById("popup");
message = document.getElementById("message");


updateScore();


off0 = new Image();
off0.src = imgpath+"black.png";
off1 = new Image();
off1.src = imgpath+"1off.png";
off2 = new Image();
off2.src = imgpath+"2off.png";
off3 = new Image();
off3.src = imgpath+"3off.png";
off4 = new Image();
off4.src = imgpath+"4off.png";
on0 = new Image();
on0.src = imgpath+"black.png";
on1 = new Image();
on1.src = imgpath+"1on.png";
on2 = new Image();
on2.src = imgpath+"2on.png";
on3 = new Image();
on3.src = imgpath+"3on.png";
on4 = new Image();
on4.src = imgpath+"4on.png";

//	Bottom row array, used by the findAdjacent2() function.
bottom = new Array();
n = 0;
for (i = 0; i < cols; i++) {
  bottom[i] = n;
  n += rows;
}

//	Top row array, used by the findAdjacent2() function.
head = new Array();
n = rows - 1;
for (i = 0; i < cols; i++) {
  head[i] = n;
  n += rows;
}

//	Main array, randomly seeds all coordinates with a number from 1-3
main = new Array();
for (i = 0; i < (cols * rows); i++) {
    main[i] = random();
    }
    drawBalls();

    if (widget.isrotationsupported){
       // change the screen orientation
       widget.setDisplayLandscape();
       }
    else
        cols = 11;
}

//	Take the ball which was clicked and finds all connected balls of the same
//	color with findAdjacent2().
function findAdjacent(numba) {
  adj = new Array();
  adj[0] = numba;
  i = 0;
  c = 0;
  findAdjacent2(adj[c]);
}

//	Rolls through the "adj" Array and adds adjacent balls of
//	the same color to the "adj" Array.

//	Checks in this order: up, right, down, left
//	up=+1  right=+10  down=-1  left=-10.

//	isBottom and isHead checks to see if the ball
//	in question is on the top row or the bottom row.
//	If the ball in question is on the bottom row, the
//	down(-1) check is disabled, if it is on the top row
//	up(+1) is disabled.

//	Uses isAdjacent() to check whether or not the ball
//	in question is allready included in the "adj" Array.
//	Does not add the ball to the array if isAdjacent() returns
//	false.
function findAdjacent2(numba) {
isBottom = 0;
isHead = 0;
for (n = 0; n < rows * 2; n++) {
  if (numba == head[n]) {
  isHead = 1;
   }
}
for (n = 0; n < rows * 2; n++) {
if (numba == bottom[n]) {
    isBottom = 1;
   }
}
if (main[numba+1] == main[numba] && isHead != 1 && isAdjacent(numba+1)) {
  i++;
  adj[i] = numba + 1;
}
if (main[numba+rows] == main[numba] && isAdjacent(numba+rows)) {
  i++;
  adj[i] = numba + rows;
}
if (main[numba-1] == main[numba] && isBottom != 1 && isAdjacent(numba-1)) {
  i++;
  adj[i] = numba - 1;
}
if (main[numba-rows] == main[numba] && isAdjacent(numba-rows)) {
  i++;
  adj[i] = numba - rows;
}
c++;
if (c == adj.length) {
    blah = 500;
}
else {
    findAdjacent2(adj[c]);
   }
}

//	Rolls through the "adj" Array, if the ball
//	in question is allready counted returns false.

function isAdjacent(numba) {
isAdj = 1
for (n=0; n<adj.length; n++) {
  if (adj[n] == numba) {
  isAdj = 0
  }
}
if (isAdj == 1) {
    return true;
}
else {
    return false;
   }
}
//  End -->